#include<string.h>
#include<math.h>
#include<stdlib.h>
#include"random.h"

int int_ran(int min, int max)
{
	return (min+(int)((double)(max-min+1)*rand()/(RAND_MAX+1.0)));
}

int sign_ran()
{
	return int_ran(0,1) ? -1 : 1;
}

double uni_ran_01()
{
	double res=((rand()+1.0)/((double)RAND_MAX+1.0));
	return res;
}

double uni_ran(double min,double  max)
{
	return (min+((max-min)*rand()/(RAND_MAX)));
}

double gauss_ran(double mean,double dev)
{
	static int iset=0;
	static double gset;
	float fac, rsq, v1, v2;

	if(iset==0) {
		do {
			v1=uni_ran(-1.0, 1.0);
			v2=uni_ran(-1.0, 1.0);
			rsq=v1*v1+v2*v2;
		} while (rsq>=1.0 || rsq==0.0);

		fac=sqrt(-2.0*log(rsq)/rsq);

		gset=v1*fac;
		iset=1;
		return (v2*fac*dev+mean);
	} else {
		iset=0;
		return (gset*dev+mean);
	}
}

void permutation(int n_points; int perm[n_points], int n_points) 
{
	int perm_vect[n_points];

	memset(perm_vect, 0, sizeof(perm_vect));

	for(int i=0; i<n_points; i++) {
		int j=int_ran(1,n_points-i); 
		int k=-1;
		while(j) if(!perm_vect[++k]) j--;
		perm_vect[k]=1;
		perm[i]=k;
	}

}
